/*******************************************************************************
Edit History of Huawei: 
<޸>     <޸ʱ>    <ⵥ>          <޸>
z00159386    2012/09/19    DTS2012091310003    ƶʹipv6ʱܴԼMTUİ
*******************************************************************************/
#ifndef __ATP_WANCORECMS_API_H__
#define __ATP_WANCORECMS_API_H__

#include "atputil.h"
#include "atpwancore.h"


/* ǰ׺ֵ */
#define WAN_PREFIX_LEN_MAX 128
/* ǰ׺Сֵ */
#define WAN_PREFIX_LEN_MIN 16
/* ǰ׺Ĭֵ */
#define WAN_PREFIX_LEN_DEFAULT 64
/* ǰ׺ʱĬֵ */
#define WAN_PREFIX_TIME_DEFAULT (60*60)

/* WAN·󳤶 */
#define ATP_WAN_PATH_LEN 128

#ifdef SUPPORT_ATP_RTU
#define ATP_WAN_IFC_LEN  16
#else
/* WANӿ󳤶 */
#define ATP_WAN_IFC_LEN  32
#endif

/* WANӿIPַ󳤶 */
#define ATP_WAN_ADDR_LEN 16
/* PPPoE Serverַ */
#define ATP_PPPOE_SERVER_ADDR  "192.168.239.1"

#ifdef SUPPORT_ATP_RTU
#define ATP_WAN_MAC_LEN  20
#else
/* MACַ󳤶 */
#define ATP_WAN_MAC_LEN    32
#endif

/* ·󳤶 */
#define ATP_WAN_LINK_NAME_LEN  32
/* ַ볤 */
#define ATP_WAN_PAD  4

/* WANֳ */
#ifdef SUPPORT_ATP_RTU
#define ATP_WAN_NAME_LEN  (32 + ATP_WAN_PAD)
#else
#define ATP_WAN_NAME_LEN  (256 + ATP_WAN_PAD)
#endif

#ifdef SUPPORT_ATP_RTU
#define ATP_WAN_STATUS_LEN 20
#define ATP_WAN_LASTERR_LEN 28
#else
/* WAN״̬ */
#define ATP_WAN_STATUS_LEN 32
/* WANӴϢ */
#define ATP_WAN_LASTERR_LEN 32
#endif
/* WANͳ */
#define ATP_WAN_CONNTYPE_LEN 16
/* WANӵַͳ */
#define ATP_WAN_ADDRTYPE_LEN 8
/*WANӵͳ*/
#define ATP_WAN_TUNNEL_TYPE_LEN 8
/*6rd ģʽ*/
#define ATP_WAN_6RD_MODE_LEN	8				
/* IPַ */
#define ATP_WAN_IPADDR_LEN 16
/* DNSб */
#define ATP_WAN_DNS_LEN (64 + ATP_WAN_PAD)
#ifdef SUPPORT_ATP_DOT1X
#define ATP_WAN_DOT1X_TYPE_LEN  24
#define ATP_WAN_DOT1X_NAME_LEN  64
#define ATP_WAN_DOT1X_PASSWORD_LEN  64
#endif

#ifdef SUPPORT_ATP_RTU
#define ATP_WAN_PPP_USER_LEN (32 + ATP_WAN_PAD)
#define ATP_WAN_PPP_PASSWD_LEN (32 + ATP_WAN_PAD)
#define ATP_WAN_PPP_AUTH_LEN 6
#define ATP_WAN_TRANSPORT_LEN 8
#define ATP_WAN_PPP_ACNAME_LEN (32 + ATP_WAN_PAD)
#define ATP_WAN_PPP_SRVNAME_LEN (32 + ATP_WAN_PAD)
#define ATP_WAN_BIND_LEN 256
#else
/* PPPû */
#define ATP_WAN_PPP_USER_LEN (64 + ATP_WAN_PAD)
/* PPP볤 */
#define ATP_WAN_PPP_PASSWD_LEN (64 + ATP_WAN_PAD)
/* PPP֤Э鳤 */
#define ATP_WAN_PPP_AUTH_LEN 8
/* PPPOE/PPPOA/PPP */
#define ATP_WAN_TRANSPORT_LEN 16
/* PPPOEʼֳ */
#define ATP_WAN_PPP_ACNAME_LEN (256 + ATP_WAN_PAD)
/* PPPOEֳ */
#define ATP_WAN_PPP_SRVNAME_LEN (256 + ATP_WAN_PAD)
/* WANб */
#define ATP_WAN_BIND_LEN 1024
#endif
/* WANб */
#define ATP_WAN_SERVICE_LEN 32
/* ̬·Э鳤 */
#define ATP_WAN_ROUTE_LEN 16
/* RIPģʽ */
#define WAN_RIP_LEN 8
/* Ӵ */
#define ATP_WAN_TRIGGER_LEN 16
/* APN */
#define ATP_WAN_APN_LEN (32 + ATP_WAN_PAD)
/* ָ */
#define ATP_WAN_DIALNUM_LEN (32 + ATP_WAN_PAD)
/* ǰ׺ */
#define ATP_WAN_PREFIXLIST_LEN (128 + ATP_WAN_PAD)
/* IPV6ַ */
#define ATP_WAN_IPV6_ADDR_LEN 64
/* IPV6 DNS */
#define ATP_WAN_IPV6_DNS_LEN (128 + ATP_WAN_PAD)
#ifdef SUPPORT_ATP_DOT1X
#define ATP_WAN_DOT1X_CMD_LEN 64
#define ATP_WAN_DOT1X_LINE_LEN 256
#endif
#ifdef SUPPORT_ATP_IPV6
#ifndef IPV6_MIN_MTU
/* <DTS2012091310003  z00159386  20120919  begin */
#define IPV6_MIN_MTU 576
/* DTS2012091310003  z00159386  20120919  end> */
#endif
#define IPV6_STD_MTU 1500
#define IPV6_ADDRESS_WAN_DISPLAY_NUM 3/*l00168621 display addr num on the web 20100824, can be modified.*/
#endif

/* ֪ͨCWMP PPPû */
#define WAN_CWMP_PPP_USER_NUM 4
/* LANĿ */
#ifdef SUPPORT_ATP_WLAN
#define WAN_LAN_NUM 8
#else
#define WAN_LAN_NUM 4
#endif
/* pppͻ˽ӿţǰ汣ppp */
#define WAN_PPPC_BASE 0xFF

#define ATP_WAN_SAME_TYPE_NUM        2

#define ATP_WAN_STR_UNCONFIG       "Unconfigured"
#define ATP_WAN_STR_ROUTED         "IP_Routed"
#define ATP_WAN_STR_IP_BRIDGED     "IP_Bridged"
#define ATP_WAN_STR_PPP_BRIDGED    "PPPoE_Bridged"
#define ATP_WAN_STR_DHCP_SPOOFED   "DHCP_Spoofed"
#define ATP_WAN_STR_DHCP           "DHCP"
#define ATP_WAN_STR_STATIC         "Static"
#define ATP_WAN_STR_SLAAC          "SLAAC"
#define ATP_WAN_STR_INTERNET       "INTERNET"
#define ATP_WAN_STR_TR069_INTERNET "TR069_INTERNET"
#define ATP_WAN_STR_TR069          "TR069"
#define ATP_WAN_STR_OTHER          "Other"
#define ATP_WAN_STR_VOICE_INTERNET "VOICE_INTERNET"
#define ATP_WAN_STR_VOICE          "VOICE"
#define ATP_WAN_STR_TR069_VOICE    "TR069_VOICE"
#define ATP_WAN_STR_VOICE_TR069_INTERNET "VOICE_TR069_INTERNET"


#define ATP_WAN_STR_IDLE           "Idle"
#define ATP_WAN_STR_ONDEMAND       "OnDemand"
#define ATP_WAN_STR_ALWAYSON       "AlwaysOn"
#define ATP_WAN_STR_MANUAL         "Manual"
#define ATP_WAN_STR_BR0            "br0"

/* <DTS2012081707617 w00189185 2012/8/28 begin  */
#ifdef SUPPORT_ATP_ATP_FMCWEB        
#define ATP_WAN_STR_NONE           "NONE"
#endif        
/* DTS2012081707617 w00189185 2012/8/28 end> */
#define ATP_WAN_STR_PAP            "PAP"
#define ATP_WAN_STR_CHAP           "CHAP"
#define ATP_WAN_STR_CHAP_PAP       "AUTO"

#define ATP_WAN_STR_CONNECTING     "Connecting"
#define ATP_WAN_STR_CONNECTED      "Connected"
#define ATP_WAN_STR_PENDING        "PendingDisconnect"
#define ATP_WAN_STR_DISCONNECTING  "Disconnecting"
#define ATP_WAN_STR_DISCONNECTED   "Disconnected"
#define ATP_WAN_STR_AUTHENTICATING "Authenticating"

#define ATP_WAN_STR_ERR_NO_CARRIER "ERROR_NO_CARRIER"
#define ATP_WAN_STR_ERR_FROCE_DISCONN "ERROR_FORCED_DISCONNECT"

#define ATP_WAN_STR_BACKUP_DISABLE "Disable"
#define ATP_WAN_STR_BACKUP_CONFIRM "Backup_Confirm"
#define ATP_WAN_STR_BACKUP_AUTO    "Backup_Auto"

#define ATP_IPV6_ENABLE_FLAG_PATH     "/proc/sys/net/ipv6/conf/all/enable"
/*  <DTS2013022804321 wanglong 2012-2-28 begin */
/* PCLINT */
#ifdef ATP_PCLINT
#define SNPRINTF(DstStr,format,arg...) 
#define STRNCPY(DstStr,SrcStr) 
#else
#define SNPRINTF(DstStr,format,arg...) \
    do \
    { \
        snprintf(DstStr,sizeof(DstStr),format,## arg); \
    }while(0)
    
#define STRNCPY(DstStr,SrcStr) \  
    do \
    {\    
        strncpy(DstStr,SrcStr,sizeof(DstStr) - 1);\
        DstStr[sizeof(DstStr) - 1] = 0; \
    }while(0)
#endif
/*  DTS2013022804321 wanglong 2012-2-28 end> */
#ifdef SUPPORT_ATP_DOT1X
#define DHCPC_DOT1X_UNPASS 0
#define DHCPC_DOT1X_PASS   1
#endif

#ifdef SUPPORT_ATP_TR181
typedef struct tagATP_INTERFACE_ST ATP_WAN_INFO_ST;
#else
typedef struct tagATP_WAN_INFO_ST ATP_WAN_INFO_ST;
#endif

/* WAN DEV нӿ */
typedef enum 
{
    /* XDSL */
    ATP_WAN_TYPE_DSL = 1,
    /* ̫ */
    ATP_WAN_TYPE_ETH = 2,
    /* POTS */
    ATP_WAN_TYPE_POTS = 4,
    /* UMTS */
    ATP_WAN_TYPE_UMTS = 8,
    /* VDSL */
    ATP_WAN_TYPE_VDSL = 16,
}ATP_WAN_TYPE_EN;

/* WAN DEV нӿ״̬ */
typedef enum 
{
    /*  */
    ATP_WAN_LINK_STATUS_UP,
    /*  */
    ATP_WAN_LINK_STATUS_DOWN,
}ATP_WAN_LINK_STATUS_EN;

/* WAN DEV · */
typedef enum
{
    /* δ */
    ATP_WAN_LINKTYPE_UNCONFIGURED,
    /* RFC2684 ATMϳŽ̫ */
    ATP_WAN_LINKTYPE_EOA,
    /* RFC2684 ATMϳŽ̫RFC2516 ̫PPPЭ飬ѽ */
    ATP_WAN_LINKTYPE_PPPOE,
    /* RFC2684 ATM֧·IP */
    ATP_WAN_LINKTYPE_IPOA,
    /* RFC2364 ATMϳPPP */
    ATP_WAN_LINKTYPE_PPPOA,
    /* RFC1577 ATMִ֧ͳIP */
    ATP_WAN_LINKTYPE_CIP,
    /* ̫ */
    ATP_WAN_LINKTYPE_ETH,
    /* POTS */
    ATP_WAN_LINKTYPE_PPP_DIALUP,
    /* PTM */
    ATP_WAN_LINKTYPE_EOP,
}ATP_WAN_LINKTYPE_EN;


/* WANЭ */
typedef enum
{
    /* UNCONFIG */
    ATP_WAN_PROTOCOL_UNCONFIGURED,
    /* PPPOE */
    ATP_WAN_PROTOCOL_PPPOE,
    /* IPOE */
    ATP_WAN_PROTOCOL_IPOE,
    /* IP BRIDGE */
    ATP_WAN_PROTOCOL_IP_BRIDGE,
    /* PPP BRIDGE */
    ATP_WAN_PROTOCOL_PPP_BRIDGE,
    /* PPPOA */
    ATP_WAN_PROTOCOL_PPPOA,
    /* IPOA */
    ATP_WAN_PROTOCOL_IPOA,
    /* PPP DIALUP */
    ATP_WAN_PROTOCOL_PPP_DIALUP,
}ATP_WAN_PROTOCOL_EN;

/* WAN  */
typedef enum
{
    /* δʼ */
    ATP_WAN_CONNTYPE_UNCONFIGURED,
    /* ·ģʽ */
    ATP_WAN_CONNTYPE_ROUTED,
    /* Žģʽ */
    ATP_WAN_CONNTYPE_BRIDGED,
    /* WANPPPַͨDHCPLAN豸 */
    ATP_WAN_CONNTYPE_DHCP_SPOOF,
}ATP_WAN_CONNTYPE_EN;

/* WAN ͣλ */
typedef enum
{
    /* ͨҵ */
    ATP_WAN_SERVICE_INTERNET = 1,
    /* TR069ר */
    ATP_WAN_SERVICE_TR069 = 2,
    /* VOICEר */
    ATP_WAN_SERVICE_VOICE = 4,
    /* ҵ */
    ATP_WAN_SERVICE_OTHER = 8,
    /* عҵ */
    ATP_WAN_SERVICE_SHARENET = 16,
}ATP_WAN_SERVICE_EN;

/* NAT */
typedef enum
{
    /* δ */
    ATP_WAN_NAT_DISABLED = 0,
    /* NAPT */
    ATP_WAN_NAT_NAPT = 1,
    /* CONE NAT */
    ATP_WAN_NAT_CONE = 2,
#ifdef SUPPORT_ATP_ALLCONENAT
    /* address restricted cone nat */
    ATP_WAN_NAT_ADDR_CONE = 3,

    /* port restricted cone nat */
    ATP_WAN_NAT_PORT_CONE = 4,
#endif

    /* NATֵ */
    ATP_WAN_NAT_MAX,
}ATP_WAN_NAT_EN;

typedef enum
{
    /* WANݵҳѯ*/
    ATP_WAN_GMSG_GET_BACKUP = 0,
    /* ATP_GMSG_SUBTYPE_ASYNC_SETֶ */
    ATP_WAN_GMSG_SET_MANUAL_DIAL = 1,
    /* WANݵҳ */
    ATP_WAN_GMSG_SET_BACKUP = 2,
#ifdef SUPPORT_ATP_WAN_AUTO_SENSING    
    /* WAN Auto-sensingǰ״̬ */
    ATP_WAN_GMSG_AUTOSENSING_STATUS = 5,
#endif
} ATP_WAN_GMSG_SUBTYPE_EN;

#ifdef SUPPORT_ATP_WAN_AUTO_SENSING
typedef enum 
{
    WAN_AUTO_SENSING_SUCCESS,            // 0: WAN Auto-sensingɹ⵽WAN
    WAN_AUTO_SENSING_LINKDOWN,           // 1:Auto-sensingģʽ£DSLETHнӿڲ
    WAN_AUTO_SENSING_DSLWANDOWN,         // 2:Auto-sensingģʽ£DSL·,PPPʧ
    WAN_AUTO_SENSING_ETHWANDOWN,         // 3:Auto-sensingģʽ£ETH·,PPPʧ
    WAN_AUTO_SENSING_PPPDOWN,            // 4:Auto-sensingģʽ£DSLETH·,PPPʧ
    WAN_FORCE_MODE_DSLDOWN,              // 5:Forced operating mode ΪDSL, DSLӿڲ
    WAN_FORCE_MODE_DSLWANDOWN,           // 6:Forced operating mode ΪDSL, DSLӿڿ,PPPʧ
    WAN_FORCE_MODE_ETHDOWN,              // 7:Forced operating mode ΪFibre, Fibreӿڲ
    WAN_FORCE_MODE_ETHWANDOWN,           // 8:Forced operating mode ΪFibre, Fibreӿڿ,PPPʧ
}ATP_WAN_AUTOSENSING_STATUS_EN;

/* WANӦͨó */
#define ATP_WAN_AUTO_SENSING_LEN  16
/* WANӦݽṹ */
typedef struct tagATP_WAN_AUTO_SENSING_ST
{
    /* ʹӦ*/
    //VOS_UINT32 ulEnable; //ݲҪ
    /* δʹӦ£ִֶһӦ */
    VOS_UINT32 ulForceSensing;
    /* Ӧɹ */
    VOS_UINT32 ulComplete;
    /* ǿӦĶʱ */
    VOS_UINT32 ulTimer;
    /* δʹӦ£ǿƳĳУDSLFibre */
    VOS_CHAR acForceMode[ATP_WAN_AUTO_SENSING_LEN];  //ɰ汾Ϊ DSLFibreҪΪ: DSL ETHAUTO
    /* ǰͣDSLFibreUnknown */
    VOS_CHAR acCurrentMode[ATP_WAN_AUTO_SENSING_LEN];
    /* һεͣDSLFibreUnknown */
    VOS_CHAR acLastState[ATP_WAN_AUTO_SENSING_LEN];
    /* start of m00132836 ADD for WAN-auto LED status 20100804*/
    /* Ӧ˸ƶʱ */
    ATP_UTIL_TIMER_ST* pLedTimer;    
    /* end of m00132836 ADD for WAN-auto LED status 20100804*/
} ATP_WAN_AUTO_SENSING_ST;

#endif

#define ATP_WAN_DOMAIN_LEN 64
#define ATP_WAN_BACKUP_MODE_LEN 32
#define ATP_WAN_BACKUP_TIMER_INTERVAL 3
#define ATP_WAN_BACKUP_INIT_DELAY 15

#ifdef SUPPORT_ATP_WAN_STATS_OVERFLOW
/* start of add by t00163975 2010-12-14 for BT-HHB3 չWANͺͽֵֽΧֳ֧4g */
// ¼ͺͽֽΪunsigned int32λֻܼ¼4g
// ܵTR098ںʵֵƣıеݶ͡
// ÿWANһ¼ʱ4gĴһͳƽ
typedef struct
{
    /* ѷֽ */
    VOS_UINT32 ulBytesSentPre;
    
    /* ѽֽ */
    VOS_UINT32 ulBytesReceivedPre;

    /* ֽڼ4gĴ */
    VOS_UINT32 uiSendOver4gCnt;   
    
    /* ֽڼ4gĴ */
    VOS_UINT32 uiRecvOver4gCnt;   
} WAN_STAT_OVERFLOW_COUNT_ST;

#define WAN_STAT_OVERFLOW_CHECK_INTERVAL  (30)    // second
#define WAN_STAT_OVERFLOW_GAP   (1000000000)    // жͳֵзתʱֵСֵ
/* end of add by t00163975 2010-12-14 for BT-HHB3 */
#endif

#ifdef SUPPORT_ATP_TR181
//!\brief 2	ATP_WAN_PostInit_NotifyRegisterʹõĺ
/*!WANCMSʼ
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_POSTINIT_PPPOES=1,
    ATP_WAN_NOTIFY_PRIORITY_POSTINIT_ROUTE_INIT,
    ATP_WAN_NOTIFY_PRIORITY_POSTINIT_ROUTE6_INIT,  
    ATP_WAN_NOTIFY_PRIORITY_POSTINIT_NATOTHER_INIT,
}ATP_WAN_NOTIFY_PRIORITY_POSTINIT;
#endif
/* WANӿշͳϢ*/
typedef struct
{
    /* ѷֽ */
    VOS_UINT32 ulBytesSent;
    /* ѽֽ */
    VOS_UINT32 ulBytesReceived;
    /* ѷͱ */
    VOS_UINT32 ulPacketsSent;
    /* ѽձ */
    VOS_UINT32 ulPacketsReceived;
    /* ʹ */
    VOS_UINT32 ulErrorsSent;
    /* մ */
    VOS_UINT32 ulErrorsReceived;
    /* ͵ */
    VOS_UINT32 ulUnicastSent;
    /* յ */
    VOS_UINT32 ulUnicastReceived;
    /* Ͷ */
    VOS_UINT32 ulDiscardSent;
    /* ն */
    VOS_UINT32 ulDiscardReceived;
    /* Ͷಥ */
    VOS_UINT32 ulMulticastSent;
    /* նಥ */
    VOS_UINT32 ulMulticastReceived;
    /* ͹㲥 */
    VOS_UINT32 ulBroadcastSent;
    /* չ㲥 */
    VOS_UINT32 ulBroadcastReceived;
    /* δ֪ĲҶ */
    VOS_UINT32 ulUnknownReceived;
}ATP_WAN_STATS_ST;

typedef struct tagCurrentWanForACS
{
#if defined (SUPPORT_ATP_IPV6) && defined (SUPPORT_ATP_CWMP_IPV6)
  VOS_CHAR acCwmpIp[ATP_ACTUAL_LEN_64];
#else    
  VOS_CHAR acCwmpIp[ATP_WAN_IPADDR_LEN];
#endif
  VOS_INT32 iPid;
  VOS_CHAR   acInterface[ATP_WAN_IFC_LEN];
} CurrentWanForACS;


#ifdef SUPPORT_ATP_CWMP
extern CurrentWanForACS g_ACSWan;
#endif

#if defined(__cplusplus)
extern "C" {
#endif

//!\brief 10	ATP_WAN_WanUpdateInfo_NotifyRegisterʹõĺ
/*!
 WanUpdateInfo
 varĿ¼һЩ״̬ļ

 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_WANUPDATEINFO_6RDTUNNEL=1,
    ATP_WAN_NOTIFY_PRIORITY_WANUPDATEINFO_SUPPORTRTU,
}ATP_WAN_NOTIFY_PRIORITY_WANUPDATEINFO;


//!\brief 13	ATP_WAN_RoutedWANUp_NotifyRegisterʹõĺ
/*! ·ģʽWAN up
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_ROUTESTART=1,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_DNSRESTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_WANBACKUPCHANGED,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_QOSWANSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_FIREWALLWANSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_ACLWANSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_NATWANSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_ALGSIPSIG,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_SIPSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_DDNSSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_IGMPPROXYRESET,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_PTWANRULSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_VPNWANRULESTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_VPNL2TPSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_ETHERIPROUTESTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_CWMPSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_DEFAULTROUTING,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_VOICESTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_6TO4TUNNELSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_6RDTUNNELSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_FIREWALLWANSTART6,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_ACLWANSTART6,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_SNTP,    
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_CLEANTRACENAT,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_LED,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_FONSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP_FTPFIREWALLSTART,
}ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANUP;

//!\brief 15	ATP_WAN_PreRoutedWANDown_NotifyRegisterʹõĺ
/*! Pre WAN down
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_PREROUTEDWANDOWN_DNSDELETE=1,
    ATP_WAN_NOTIFY_PRIORITY_PREROUTEDWANDOWN_VOICESTOPREGIT,
    ATP_WAN_NOTIFY_PRIORITY_PREROUTEDWANDOWN_CWMPSTOP,
    ATP_WAN_NOTIFY_PRIORITY_PREROUTEDWANDOWN_TR111STOP,
    ATP_WAN_NOTIFY_PRIORITY_PREROUTEDWANDOWN_LEDSTOP,
}ATP_WAN_NOTIFY_PRIORITY_PREROUTEDWANDOWN;


//!\brief 16	ATP_WAN_RoutedWANDown_NotifyRegisterʹõĺ
/*! ·ģʽWAN down
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_CWMPSTOP=1,
    /* <DTS2012091203320 z81004485 2012/9/12 begin  */
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_LEDSTOP,
    /* DTS2012091203320 z81004485 2012/9/12 end> */
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_VPNWANRULESTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_VPNL2TPSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_DNSRESTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_ROUTESTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_WANBACKUPCHANGED,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_QOSWANSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_FIREWALLWANSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_ACLWANSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_NATWANSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_ALGSIPSIG,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_ALGSIPSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_DDNSSTOP,    
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_IGMPPROXYRESET,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_PTWANRULSTART,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_DEFAULTROUTING,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_VOICESTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_6TO4TUNNELSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_6RDTUNNELSTOP,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_FIREWALLWANSTOP6,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_ACLWANSTOP6,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_SNTPPROC,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_CLEANTRACENAT,
    ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN_FONSTOP,
}ATP_WAN_NOTIFY_PRIORITY_ROUTEDWANDOWN;


//!\brief 25	WanPreWanUpdateInfoNotifyInitʹõĺ
/*! 
pre wan udpate info
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_PREWANUPDATEINFO_DNSRESTART=1,
}ATP_WAN_NOTIFY_PRIORITY_PREWANUPDATEINFO;

#ifdef SUPPORT_ATP_IPV6
//!\brief 17	ATP_WAN_WanIpv6UpdateInfo_NotifyRegisterʹõĺ
/*! 
 WanUpdateInfo
 ipv6varĿ¼һЩ״̬ļ

 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEINFO_DSLITETUNNEL=1,
}ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEINFO;

//!\brief 18	ATP_WAN_WanIpv6UpProcess_NotifyRegisterʹõĺ
/*! 
 ipv6 WAN up 
 WanIpv6UpProcess
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_ROUTESTART=1,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_DNSRESTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_RADVD,  
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_DHCP6S,   
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_FIREWALLWANSTART6,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_MLDPROXYRESET,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_IPV6COMMONGETINT,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_CWMPSTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_IPV6MSSADJUSTSTART,   
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_IPV6NL,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_SNTP,    
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_DSLITETUNNELSTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_LED,   
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS_PRIVACYBUTTONSTART,
}ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPPROCESS;

//!\brief 19	ATP_WAN_WanIpv6DownProcess_NotifyRegisterʹõĺ
/*! 
 ipv6 WAN down 
 WanIpv6DownProcess

 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_MLDPROXYRESET=1,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_CWMPSTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_ROUTESTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_FIREWALLWANSTOP6,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_IPV6MSSADJUSTSTOP,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_IPV6NL,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_DSLITETUNNELSTOP,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_RADVD,    
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_DHCP6S,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS_SNTPPROC,
}ATP_WAN_NOTIFY_PRIORITY_WANIPv6DOWNPROCESS;


//!\brief 20	ATP_WAN_WanIpv6UpdateProcess_NotifyRegisterʹõĺ
/*! 
 ipv6 WAN update
 WanIpv6UpdateProcess

 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEPROCESS_DNSRESTART=1,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEPROCESS_CWMPSTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEPROCESS_IPV6NL,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEPROCESS_DSLITETUNNELSTART,
    ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEPROCESS_LED,
}ATP_WAN_NOTIFY_PRIORITY_WANIPv6UPDATEPROCESS;

//!\brief 26	ATP_WAN_PreWanIpv6UpdateInfo_NotifyRegisterʹõĺ
/*! 
pre wan6 udpate info
 *
 */
typedef enum
{
    ATP_WAN_NOTIFY_PRIORITY_PREWANIPV6UPDATEINFO_DNSRESTART=1,
    ATP_WAN_NOTIFY_PRIORITY_PREWANIPV6UPDATEINFO_LEDSTOP,
}ATP_WAN_NOTIFY_PRIORITY_PREWANIPV6UPDATEINFO;

#endif



/*!
  \brief ·WAN UPʱעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_RoutedWANUp_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);



/*!
  \brief ·WAN DOWNϢǰעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_PreRoutedWANDown_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

/*!
  \brief ·WAN DOWNʱעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_RoutedWANDown_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

/*!
  \brief WANϢ仯ʱעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_WanUpdateInfo_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);


/*!
  \brief WANϢǰעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_PreWanUpdateInfo_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);


#ifdef SUPPORT_ATP_IPV6
/*!
  \brief IPV6 WANϢʱעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_WanIpv6UpdateInfo_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

/*!
  \brief IPV6 WAN UPʱעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_WanIpv6UpProcess_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

/*!
  \brief IPV6 WAN DOWNʱעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_WanIpv6DownProcess_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

/*!
  \brief IPV6 WAN ״̬仯עắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_WanIpv6UpdateProcess_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

/*!
  \brief IPV6 WANϢǰעắ
  \param[in]  pfProc: עĴ
  \param[in]  ulPriority: ȼ
  \param[in]  *pvNotifyHook: Ӳ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_MSG_RET_PARA_ERR
*/
VOS_UINT32 ATP_WAN_PreWanIpv6UpdateInfo_NotifyRegister(AtpNotifierProc                 pfProc,
                                            						VOS_UINT32                      ulPriority,
                                            						VOS_VOID                        *pvNotifyHook);

#endif


VOS_UINT32 WanPreWanUpdateInfoNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanUpdateInfoNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanRoutedWANUpNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanPreRoutedWANDownNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanRoutedWANDownNotifierDoNotify(VOS_CHAR* pszWanPath);

VOS_UINT32 WanRoutedWANUpNotifyInit(VOS_VOID);
VOS_UINT32 WanRoutedPreWANDownNotifyInit(VOS_VOID);
VOS_UINT32 WanRoutedWANDownNotifyInit(VOS_VOID);
VOS_UINT32 WanUpdateInfoNotifyInit(VOS_VOID);
VOS_UINT32 WanPreWanUpdateInfoNotifyInit(VOS_VOID);


#ifdef SUPPORT_ATP_IPV6
VOS_UINT32 WanIpv6UpdateInfoNotifyInit(VOS_VOID);//  17.
VOS_UINT32 WanIpv6UpProcessNotifyInit(VOS_VOID);//  18.
VOS_UINT32 WanIpv6DownProcessNotifyInit(VOS_VOID);//  19
VOS_UINT32 WanIpv6UpdateProcessNotifyInit(VOS_VOID);//  20  
VOS_UINT32 WanPreWanIpv6UpdateInfoNotifyInit(VOS_VOID);//26
VOS_UINT32 ATP_WAN_WanIpv6UpProcess_NotifyRegister(AtpNotifierProc pfProc, VOS_UINT32 ulPriority,VOS_VOID *pvNotifyHook);
VOS_UINT32 ATP_WAN_WanIpv6DownProcess_NotifyRegister(AtpNotifierProc pfProc, VOS_UINT32 ulPriority, VOS_VOID *pvNotifyHook);
VOS_UINT32 WanPreWanIpv6UpdateInfoNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanIpv6UpdateInfoNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanIpv6UpProcessNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanIpv6DownProcessNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanIpv6UpdateProcessNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanPostIPV6InitNotifierDoNotify(VOS_VOID);
#ifdef SUPPORT_ATP_FIREWALL_B890
VOS_UINT32 WanIpv6ConnectingNotifyInit();
VOS_UINT32 ATP_WAN_WanIpv6Connecting_NotifyRegister(AtpNotifierProc pfProc, VOS_UINT32 ulPriority, VOS_VOID *pvNotifyHook);
VOS_UINT32 WanIpv6ConnectingNotifierDoNotify(VOS_CHAR* pszWanPath);
VOS_UINT32 WanIpv6ConnectFailNotifyInit();
VOS_UINT32 ATP_WAN_WanIpv6ConnectFail_NotifyRegister(AtpNotifierProc pfProc, VOS_UINT32 ulPriority, VOS_VOID *pvNotifyHook);
VOS_UINT32 WanIpv6ConnectFailNotifierDoNotify(VOS_CHAR* pszWanPath);
#endif  /* SUPPORT_ATP_FIREWALL_B890 */
#endif

#ifdef SUPPORT_ATP_UNIVERSAL_XTM_QOS
VOS_UINT32 WANPPPOAWanUpProcNotifierDoNotify(VOS_CHAR* pszInterfaceName);
VOS_UINT32 WANPPPOAWanDnProcNotifierDoNotify(VOS_CHAR* pszInterfaceName);
#endif

#if defined(__cplusplus)
}
#endif
#endif
